/*
 * display.c
 *
 *  Created on: 7  2024 .
 *      Author: Andrej
 */

#include "display.h"

//Strobe pulse
void pulse_stb(void)
{
	STROBE_HIGH
	STROBE_LOW

}

//Write one byte to address VRAM
void write_byte(uint8_t vdata, uint16_t add)
{
	LatchDATA
	GPIOA->ODR = vdata;
	pulse_stb();

	LatchLADD
	GPIOA->ODR = (add & 0xFF);
	pulse_stb();

	LatchHADD
	GPIOA->ODR = (add >> 8);
	pulse_stb();

	WriteCMD
	pulse_stb();
}

//     ,   
void fill_display(uint8_t color)
{
	uint8_t fon = color | (color << 4);
	for(int i = 0; i < 4800; i++) write_byte(fon, i + ATTR_ADD);
}

//   INK  PAPER
void fill_attrs(uint8_t ink_color, uint8_t paper_color)
{
	uint8_t fon = paper_color | (ink_color << 4);
	for(int i = 0; i < 4800; i++) write_byte(fon, i + ATTR_ADD);
}

//     x y
void fill_attr(uint8_t ink_color, uint8_t paper_color, uint16_t x, uint16_t y)
{
	uint16_t add = y*80 + x  + ATTR_ADD;
	uint8_t fon = paper_color | (ink_color << 4);
	write_byte(fon, add);
}

void fill_chram(uint8_t ch)
{
	for(int i = 0; i < 4800; i++) write_byte(ch, i);
}

//     x y
void write_char(uint8_t ch, uint16_t x, uint16_t y)
{
	uint16_t add = y*80 + x;
	write_byte(ch, add);
}

//    x y
void write_string(uint8_t *ch, uint16_t x, uint16_t y)
{
	uint16_t add = y*80 + x;

	int i = 0;
	while(ch[i] != '\0')
	{
		write_byte(ch[i], add + i);
		i++;
	}
}

//    (1-3)
void choose_charBank(uint8_t bank)
{
	if(bank < 1 || bank > 3) return;

	LatchDATA
	GPIOA->ODR = bank;
	pulse_stb();

	ChooseBANK
	pulse_stb();
}


